#include "Contiguous3DVector.h"
#include <iostream>
#include "TFile.h"
#include "TTree.h"
#include "TRandom3.h"

int main() {
  gRandom = new TRandom3();

  TFile * outputTreeFile = new TFile("$HOME/Desktop/test.root", "recreate");

  outputTreeFile->cd();
  
  Contiguous3Vector<float> test(3,3,3);

  TTree * tree = new TTree("tree", "ROOT tree");
  tree->Branch("test", test.data(), "test[3][3][3]/F");

  // std::cout << test.size() << " | " << test[0].size() << " | " << test[0][0].size() << std::endl;
  
  for (std::size_t e = 0; e < 1000; e++) {
  
	for (std::size_t i = 0; i < test.size(); i++) {
	  for (std::size_t j = 0; j < test[i].size(); j++) {
		for (std::size_t k = 0; k < test[i][j].size(); k++) {
		  test[i][j][k] = gRandom->Gaus(3.0, 1.0);
		  // std::cout << "test[" << i << "][" << j << "][" << k << "] = " << test[i][j][k] << std::endl;
		}
	  }
	}
	tree->Fill();
  }
  tree->Write();
  outputTreeFile->Close();
}
